<?php
namespace FiloBlu\Flow\Model\Filters;

/**
 * Class SetDefaultLocale
 * @package FiloBlu\Flow\Model\Filters
 */
class SetDefaultLocale extends AbstractFilter {

    /**
     * @var \FiloBlu\Flow\Helper\DataFactory
     */
    protected $dataFactory;

    /**
     * SetDefaultLocale constructor.
     * @param \FiloBlu\Flow\Helper\DataFactory $dataFactory
     */
    public function __construct( \FiloBlu\Flow\Helper\DataFactory $dataFactory)
    {
        $this->dataFactory = $dataFactory;
    }

    /**
     * @param $value
     * @param $args
     * @return mixed|string
     */
    public function filter($value,$args){

        $v = trim($value);

        if($v == '')
        {
            return '';
        }

        $default_locale = $args['default'];
        $sku_field = (int)$args['sku'];
        $sku = $this->_row[$sku_field];
        
        $helperProduct = $this->dataFactory->get();
        $stores = implode(';', $helperProduct->getStoresCodeByLocale($default_locale));
        
        return $value.'|||'.$stores.'|||'.$sku;
    }

}

