<?php

namespace FiloBlu\Flow\Model\From\Entity;
/**
 * Class Attribute
 * @package FiloBlu\Flow\Model\From\Entity
 */
class Attribute extends AbstractEntity
{
    /**
     * @return |null
     * @throws \Exception
     */
    protected function getObject()
    {
        parent::getObject();

        if (is_null($this->_objectEntity)) {
            return $this->_objectEntity;
        }
        if (!$this->getObjectId()) {
            throw new \Exception('No id found for model ' . $this->getEntityModel() . ' with given identifier ' . $this->_entityIdentifier);
        }
        if ($this->_entityTypeCode != 'product_attribute') {
            throw new \Exception('We don\'t manage ' . $this->_entityTypeCode . ' attributes yet');
        } else {
            $this->_objectEntity = \Magento\Framework\App\ObjectManager::getInstance()->create('\Magento\Eav\Model\Config')
                ->getAttribute('catalog_product', $this->getObjectId());
        }

        $this->_objectEntity->setStoreId($this->_storeId);
        if (!$this->_objectEntity->getId()) {
            throw new \Exception('No instance found for model' . $this->getEntityModel() . ' with id ' . $this->getObjectId());
        }
    }

    /**
     * @return string|null
     */
    protected function getEntityModel()
    {
        if (is_null($this->_entityTypeModel)) {
            $this->_entityTypeModel = 'eav/entity_attribute';
        }

        return $this->_entityTypeModel;
    }
}
